
#########################################################################
# dot.profile.01.sh
#echo dot.profile.01.sh

# You must edit these:
TO="root"
CC="palvelupiste@cc.jyu.fi"
#BCC="$USER"
BCC="juhtolv@jyu.fi"



HOME_PROFILE=1
export HOME_PROFILE

if test "$ALREADY_ZSH" = "0" -o ! -n "$ALREADY_ZSH"
then
    if test "$SHELL" = "/bin/zsh" -o "$SHELL" = "/usr/bin/zsh"
    then
        ALREADY_ZSH="1"
    else
        ALREADY_ZSH="0"
    fi
fi

if test "$ALREADY_BASH" = "0" -o ! -n "$ALREADY_BASH"
then
    if test "$SHELL" = "/bin/bash" -o "$SHELL" = "/usr/bin/bash"
    then
        ALREADY_BASH="1"
    else
        ALREADY_BASH="0"
    fi
fi

if test "$ALREADY_KSH" = "0" -o ! -n "$ALREADY_KSH"
then
    if test "$SHELL" = "/opt/ast/bin/ksh" -o "$SHELL" = "/bin/ksh93" -o "$SHELL" = "/usr/bin/ksh93" -o "$SHELL" = "/usr/dt/bin/ksh" -o "$SHELL" = "/bin/ksh" -o "$SHELL" = "/usr/bin/ksh" -o "$SHELL" = "/bin/mksh" -o "$SHELL" = "/bin/pdksh"
    then
        ALREADY_KSH="1"
    else
        ALREADY_KSH="0"
    fi
fi

if test "$ALREADY_SH" = "0" -o ! -n "$ALREADY_SH"
then
    if test "$SHELL" = "/usr/xpg4/bin/sh" -o "$SHELL" = "/usr/bin/jsh" -o "$SHELL" = "/bin/ash" -o "$SHELL" = "/bin/dash"
    then
        ALREADY_SH="1"
    else
        ALREADY_SH="0"
    fi
fi

export ALREADY_ZSH
export ALREADY_BASH
export ALREADY_KSH
export ALREADY_SH

CONTINUE_SEARCH="0"

ZSH_FOUND="0"
for f in /bin/zsh /usr/bin/zsh
do
    if test -f "$f" 
    then
        if test "$CONTINUE_SEARCH" = "0"
        then
            BESTSHELL="$f"
            export BESTSHELL
            #echo "$BESTSHELL found"
        fi
        export ZSH_FOUND="1"
        CONTINUE_SEARCH="1"
        break 1
    fi
done

if test "$CONTINUE_SEARCH" = "0"
then
    echo "There is no Z Shell at all. Trying to find Bourne Again Shell ..."
fi
export BASH_FOUND="0"
for f in /bin/bash /usr/bin/bash
do
    if test -f "$f"
    then
        if test "$CONTINUE_SEARCH" = "0"
        then
            BESTSHELL="$f"
            export BESTSHELL
            #echo "$BESTSHELL found"
        fi
        export BASH_FOUND="1"
        CONTINUE_SEARCH="1"
        break 1
    fi
done

if test "$CONTINUE_SEARCH" = "0"
then
    echo "There is no Bourne Again Shell at all. Trying to find Korn Shell ..."
fi
export KSH_FOUND="0"
for f in /opt/ast/bin/ksh /bin/ksh93 /usr/bin/ksh93 /usr/dt/bin/dtksh /bin/ksh /usr/bin/ksh /bin/mksh /bin/pdksh
do
    if test -f $f
    then
        if test "$CONTINUE_SEARCH" = "0"
        then
            BESTSHELL="$f"
            export BESTSHELL
            #echo "$BESTSHELL found"
        fi
        export KSH_FOUND="1"
        CONTINUE_SEARCH="1"
        break 1
    fi
done

if test "$CONTINUE_SEARCH" = "0"
then
    echo "There is no Korn Shell at all. Trying to find some Bourne Shell ..."
fi
for f in /usr/xpg4/bin/sh /usr/bin/jsh /bin/dash /bin/ash /bin/sh /bin/bsh
do
    if test -f $f
    then
        if test "$CONTINUE_SEARCH" = "0"
        then
            BESTSHELL="$f"
            export BESTSHELL
            CONTINUE_SEARCH="1"
            #echo "$BESTSHELL found"
        fi
        break 1
    fi
done

export BESTSHELL

rm -f ~/shellcomplaint.txt
HOSTNAME="`hostname`"

if test "$ZSH_FOUND" = "0"
then
    touch ~/shellcomplaint.txt
fi

if test "$BASH_FOUND" = "0"
then
    touch ~/shellcomplaint.txt
fi

if test "$KSH_FOUND" = "0"
then
    touch ~/shellcomplaint.txt
fi

if test -f ~/shellcomplaint.txt -a ! -f ~/.shellcomplaints/${HOSTNAME}
then
    touch ~/.shellcomplaints/${HOSTNAME}
    echo "Argh! Some shell is missing. Starting to complain ..."
    echo "Argh! It seems computer called" >> ~/shellcomplaint.txt
    echo "$HOSTNAME" >> ~/shellcomplaint.txt
    echo "lacks at least one of those modern Bourne-like shells!: " >> ~/shellcomplaint.txt

    if test "$ZSH_FOUND" = "0"
    then
        echo "- Z Shell"
        echo "- Z Shell" >> ~/shellcomplaint.txt
        echo "- Z Shell" >> ~/.shellcomplaints/${HOSTNAME}
    fi

    if test "$BASH_FOUND" = "0"
    then
        echo "- Bourne Again Shell"
        echo "- Bourne Again Shell" >> ~/.shellcomplaint.txt
        echo "- Bourne Again Shell" >> ~/.shellcomplaints/${HOSTNAME}
    fi

    if test "$KSH_FOUND" = "0"
    then
        echo "- Korn Shell (AT&T KSH, mksh or pdksh)"
        echo "- Korn Shell (AT&T KSH, mksh or pdksh)" >> ~/shellcomplaint.txt
        echo "- Korn Shell (AT&T KSH, mksh or pdksh)" >> ~/.shellcomplaints/${HOSTNAME}
    fi

    echo "
Please, rectify this awful situation ASAP (or tell me, if they are
located in some bizarre place)!

This E-Mail was automatically generated by my ~/.profile :-P :^)

-- " >> ~/shellcomplaint.txt
cat ~/.signature >> ~/shellcomplaint.txt

    #" >> ~/shellcomplaint.txt

    # In Sun Solaris only mailx provides enough features for my purposes.
    # (Flags -s , -b and -c)
    # I have symlink ${HOME}/bin/mailx -> /bin/mail , because Red Hat Linux
    # do not have binary called mailx or link called mailx to binary called
    # mail, but in fact that /bin/mail of Red Hat Linux behaves like mailx
    # of Sun Solaris

    OLDPATH="$PATH"
    PATH="${PATH}:${HOME}/bin"
    export PATH

    cat ~/shellcomplaint.txt | mailx -s "$HOSTNAME lacks some shell" -b $BCC -c $CC $TO
    #  cat ~/shellcomplaint.txt | mailx -v -s "$HOSTNAME lacks some shell" -b juhtolv@cc.jyu.fi -c oper@cc.jyu.fi root
    #  cat ~/shellcomplaint.txt | mailx -v -s "$HOSTNAME lacks some shell" -b juhtolv juhtolv
    #  mutt -i ~/shellcomplaint.txt -s "$HOSTNAME lacks some shell" -b juhtolv@cc.jyu.fi -c oper@cc.jyu.fi root
    #  mutt -i ~/shellcomplaint.txt -s "$HOSTNAME lacks some shell" -b juhtolv@cc.jyu.fi -c juhtolv@cc.jyu.fi juhtolv@cc.jyu.fi
    PATH="${OLDPATH}"
    export PATH

    /bin/rm -f ~/shellcomplaint.txt
elif test -f ~/shellcomplaint.txt -a -f ~/.shellcomplaints/${HOSTNAME}
then
    echo "Some shell is missing, but you have complained about it already:"
    cat "${HOME}/.shellcomplaints/${HOSTNAME}"
    /bin/rm -f ~/shellcomplaint.txt
fi

unset CONTINUE_SEARCH
unset ZSH_FOUND
unset BASH_FOUND
unset KSH_FOUND
#echo BESTSHELL=${BESTSHELL}

# ftp://ftp.oreilly.com/pub/examples/power_tools/unix/split/sh_logout
#echo "Setting logout behaviour"
#trap '. $HOME/.sh_logout.sh ; exit' 0

# If you want to temporarily use other shell as your login-shell,
# redefine $BESTSHELL here:

#export BESTSHELL="/bin/bash"

# And now, switch shell, if needed:

if [ -n "$HOME_SWITCH_SHELL" ]
then
    if [ "$HOME_SWITCH_SHELL" -gt 0 ]
    then
        :
        #  echo PAH ~/.switch_shell
    fi
else

    case "$BESTSHELL" in
        # ftp://ftp.oreilly.com/pub/examples/power_tools/unix/split/sh_logout
        #echo "Setting logout behaviour"
        #trap '. $HOME/.sh_logout.sh; exit' 0
        *zsh*|*bash*)
        :
        ;;
        *)
        trap '. $HOME/.sh_logout.sh 2> /dev/null ' 0
    esac

    case $BESTSHELL in
        *zsh*)
        if test "$ALREADY_ZSH" = "0"
        then
            unset ENV
            BASH_ENV="$HOME/.bashrc"
            export BASH_ENV
            test -e ${HOME}/.switch_shell && . ${HOME}/.switch_shell -d $BESTSHELL -il
        fi
        ;;

        *bash*)
        if test "$ALREADY_BASH" = "0"
        then
            BASH_ENV=$HOME/.bashrc
            export BASH_ENV
            ENV=$HOME/.bashrc
            export ENV
            test -e ${HOME}/.switch_shell && . ${HOME}/.switch_shell -d $BESTSHELL -i
        fi
        ;;

        *ksh*)
        if test "$ALREADY_KSH" = "0"
        then
            BASH_ENV=$HOME/.bashrc
            export BASH_ENV
            ENV=$HOME/.kshrc
            export ENV
            trap '. $HOME/.sh_logout.sh 2> /dev/null ' 0
            test -e ${HOME}/.switch_shell && . ${HOME}/.switch_shell -d $BESTSHELL -ims
        fi
        ;;

        *)
        trap '. $HOME/.sh_logout.sh 2> /dev/null ' 0
    esac

    case $BESTSHELL in
        */ash|*/dash*)
        if test "$ALREADY_SH" = "0"
        then
            BASH_ENV=$HOME/.bashrc
            export BASH_ENV
            ENV=$HOME/.shinit.sh
            export ENV
            test -e ${HOME}/.switch_shell && . ${HOME}/.switch_shell -d $BESTSHELL -ims
        fi
        ;;

        *jsh*|*/bsh)
        if test "$ALREADY_SH" = "0"
        then
            BASH_ENV=$HOME/.bashrc
            export BASH_ENV
            ENV=$HOME/.shinit.sh
            export ENV
            test -e ${HOME}/.switch_shell && . ${HOME}/.switch_shell -d $BESTSHELL -is
        fi
        ;;

        *)
        :
    esac

fi


